sampler  tex0   : register(s0);
float4   cnt    : register(c0);
float    PI = 3.141592653;
#define  BIAS   0.0001f

struct VS_OUTPUT {
  float4 pos : POSITION;
  float4 tex : TEXCOORD0;
};

//̂܂psɓn
VS_OUTPUT vs_main(VS_OUTPUT input) {
  VS_OUTPUT ret = (VS_OUTPUT)0;
  ret.pos = input.pos;
  ret.tex = input.tex;
  return ret;
}

float inter_sphere(float3 ro, float3 rd, float3 sphere, float r) {
  float3 d = ro - sphere;
  float  b = dot(rd, d);
  float  c = dot(d, d) - r * r;
  float  t = b * b - c;
  if(t > 0) {
    return -b - sqrt(t);
  }
  return 0;
}

float inter_plane(float3 ro, float3 rd, float3 plane, float D) {
  float4 ret = (float4)0;
  float  t   = ( (dot(ro, plane) - D ) / dot(rd, plane) );
  if(t > 0) {
    return t;
  }
  return 0;
}


float3 genpos(int i, float t) {
  float x = cos(3.2 * i );
  float y = cos(3 * frac(t) + i) + sin(t);
  float z = sin(4 * i + frac(t)) * (t % 2);
  return float3(x, y, z);
}


float4 ps_main(float2 p:texcoord, float2 v : vpos) : color {
  float sline = 1;
  if(v.y <  80) return 0;
  if(v.y > 400) return 0;
  float  timer   = cnt.x * 0.2;
  //float3 light   = float3(-0.2, -0.8,  -0.2);
  float3 light  = float3(sin(timer * 2), cos(timer * 3),  -sin(timer * 3) * 4) * 0.3;
  float3 color   = float3(0, 0,  0);
  float3 eye     = float3(0, 0.3, -2);
  float3 plane   = normalize(float3(0.2 + sin(timer), 1 + cos(timer * 0.2), 0.1 ));
  float3 dir     = normalize(float3(p.x * 1.25, p.y, -1) - eye);
  float  t       = 9999;
  float  amb     = 0.1;
  float  R       = 0.2;
  int    Sphere  = 30;
  bool   ishit   = false;
  float3 norm    = 0;
  float3 l_light = 0;

  //Sphere
  for(int i = 0 ; i < Sphere; i++) {
    float3 pos = genpos(i, timer);
    float tt = inter_sphere(eye, dir, pos,  R);
    if(tt > 0 && tt < t) {
      t = tt;
      l_light = normalize(light - pos);
      norm  = normalize( ( (t - BIAS) * dir + eye) - pos );
      color = 0.2 + float4(0.9, 0.7, 0.4, 1) * dot(l_light, norm);
      ishit = true;
    }
  }
  
  {
    float tt = inter_sphere(eye, dir, light,  0.01);
    if(tt > 0 && tt < t) {
      return 1;
    }
  }
  
  //Plane
  {
    float tt = inter_plane(eye, dir, plane, 1);
    if(tt > 0 && tt < t) {
      t       = tt;
      norm    = plane;
      l_light = normalize(light - ( (t - BIAS) * dir + eye));
      color   = float4(0.8, 0.2, 0.1, 1) * dot(l_light, norm);
      ishit   = true;
    }
  }
  
  //Sphere Shadow
  if(ishit == true) {
    float3 inter = (t - BIAS) * dir + eye;
    t = length(light - inter);
    float3 s_dir = normalize(light - inter);
    for(int i = 0 ; i < Sphere; i++) {
      float3 pos = genpos(i, timer);
      float tt = inter_sphere(inter, s_dir, pos, R);
      if(tt > 0 && tt < t) {
        color *= 0.7;
        //break
      }
    }
  }
  return float4(color * sline, 1) + amb;
}

//Ȃ
technique shader {
  pass {
    VertexShader = compile ps_3_0 vs_main();
    PixelShader  = compile ps_3_0 ps_main();
  }
}


